/* GIMMIX project, University of Applied Sciences Giessen */

#include <string.h>

char *suffixes[] = { ".c", ".i", ".mms", ".o", ".out", 0 };
char inputs[256] = "";
char *include[] = { "-I" LCCDIR "../include", 0 };

char *cpp[] = {
  LCCDIR "cpp",
  "-D__STDC__=1",
  "-DLANGUAGE_C",
  "-D_LANGUAGE_C",
  "-D__LANGUAGE_C__",
  "-DMMIX",
  "-Dmmix",
  "-D_MMIX",
  "-D_mmix",
  "-DUNIX",
  "-Dunix",
  "-D_UNIX",
  "-D_unix",
  "$1", "$2", "$3",
  0
};

char *com[] = {
  LCCDIR "rcc",
  "-target=mmix/unix",
  "$1", "$2", "$3",
  0
};

char *as[] = {
  "/bin/cp",
  "$1", "$2", "$3",
  0
};

char *ld[] = {
  LCCDIR "alwrap",
  LCCDIR "al",
  "-b", "200",
  "-x",
  "-o", "$3",
  "--files",
  LCCDIR "../lib/c0.mms",
  "$1", "$2",
  LCCDIR "../lib/c1.mms",
  0
};

extern char *concat(char *, char *);

int option(char *arg) {
	if (strncmp(arg, "-lccdir=", 8) == 0) {
		cpp[0] = concat(&arg[8], "/cpp");
		include[0] = concat("-I", concat(&arg[8], "/include"));
		com[0] = concat(&arg[8], "/rcc");
		ld[8] = concat("-L", &arg[8]);
	} else if (strcmp(arg, "-kernel") == 0) {
		ld[8] = "";
		ld[11] = "";
	} else
		return 0;
	return 1;
}
