
%
% Prints out the context of the rK and rQ register.
%
	LOC	#0000ffff00000000

Main	JMP	Start

%	$0	string to output, gets converted to ASCII
%	$1	base address of terminal registers
%		+16 is transmitter status
%		+24 is transmitter data
%	$2	auxiliary data

pBuf	IS	$0
TBase	IS	$1
Tmp	IS	$2
Count	IS	$3
Char	IS	$4

PrintS	SETH	TBase,#8001		% set terminal base address
	SETH	Count,#0		% Also clears the other 48-Bits

	LDBU	Char,pBuf,Count		% Load a character
	BZ	Char,2F			% Terminating char hast to be #0

1H	LDOU	Tmp,TBase,16		% put status word into Tmp
	AND	Tmp,Tmp,#1		% extract LSB
	PBZ	Tmp,1B			% loop while transmitter not ready
		
	STOU	Char,TBase,24		% write character to terminal

	ADDU	Count,Count,1 		% and count the characters
	LDBU	Char,pBuf,Count		% Load a character
	PBNZ	Char,1B			% Terminating char hast to be #0

	ADDU	$0,Count,0		% Copy  Charsacter-count to $0	
2H	POP	1,0			% and return it


PrintLF	SETH	$0,#8001		% set terminal base address

	SETL	$1,#0d			% Load cariage-return character

1H	LDOU	$2,$0,16		% put status word into Tmp
	AND	$2,$2,#1		% extract LSB
	PBZ	$2,1B			% loop while transmitter not ready
		
	STOU	$1,$0,24		% write character to terminal

	SETL	$1,#0a			% Load cariage-return character

2H	LDOU	$2,$0,16		% put status word into Tmp
	AND	$2,$2,#1		% extract LSB
	PBZ	$2,2B			% loop while transmitter not ready
		
	STOU	$1,$0,24		% write character to terminal

3H	POP	0,0			% and return it


%	Prints the Hexadezimalnumber in Register $0
%
%	$3 	Pointer to Static-Digit-Buffer
%	$1	Actual Digit (Remainder from last /16 )
%	$2	Tmp

PrintH	GETA	$3,HexBuf		% Get Buffer-Pointer
	ADD	$3,$3,18		% Move to last digitf

	
1H	DIV	$0,$0,16		% extract least digit into rR
	GET	$1,6			% get digit from rR into $1

	CMP	$2,$1,9			% Check if 0..9
	PBNP	$2,2F			% cause most case, jump to
	ADDU	$1,$1,'a'-10		% else convert a a to 'a'
	JMP	3F
2H	ADDU	$1,$1,'0'		% convert 0 to '0'
3H	STBU	$1,$3			% Store at current Bufferpos
	SUBU	$3,$3,1			% And move a digit higher
	PBNZ	$0,1B			% If not finished continue

	ADD	$3,$3,1			% Move pointer to last used digit
	GET	$1,rJ			% restore "return jump"-register
  	PUSHJ	$2,PrintS		% Give out the hexadezimal-number
        PUT	rJ,$1			% restore "return jump"-register
	POP	0,0			% return nothing

%
%	Prints contents of rQ and rK.
%	rQ is the "trap Quest"-register and rK the "trap-mask"-register
%	It primaryprints the value of the program-flags.
%	
%	Tmp	IS	$0	
%	RetAdr	IS	$1
%	CpOfrK	IS	$2	% Contains a "working" copy of rK or rQ
%

Txt_rK	BYTE	"rK =",#d,#a,#a,0
Txt_rQ	BYTE	"rQ =",#d,#a,#a,0
	
WrtTrap	GET	$1,rJ		% Save the adress of caller

	GETA	$3,Txt_rQ
	PUSHJ	$2,PrintS

	SETL	$4,32		% Set first-bit
	SETL	$5,39		% Set last-bit
	GETA	$6,Txt_Ptr	% Set bit-names
	SETL	$7,30		% Set tab-size

	GET	$3,rQ		% Get content of Traip-Questregister.
	PUSHJ	$2,WrBtRg
	PUSHJ	$2,PrintLF

	GETA	$3,Txt_rK
	PUSHJ	$2,PrintS

	SETL	$4,32
	SETL	$5,39
	GETA	$6,Txt_Ptr
	SETL	$7,30

	GET	$3,rK		% Get content of Traip-Maskregister.
	PUSHJ	$2,WrBtRg
	PUSHJ	$2,PrintLF

	PUT	rJ,$1		% restore rJ
	POP	0,0		% and return.

%
%	Prints a specifc range of bits with a description. 
%	
%	$0	Octabyte with bits.
%	$1	First bit number to print (0-based).
%	$2	Last bit number to print.
%	$3	Pointer to field of Textpointer, 
%		first pointer points to text for bit $1,
%		$3+8*($2-$1) points to text for bit $2.
%	$4	Max. width of bit-texts
%
%
%	RetAdr	IS	$5
%	Tmp	IS	$6
%	IterBit	IS	$7
%	TxtPtr	IS	$10

WrBtRg	GET	$5,rJ		% Save adress of caller

	SETL	$6,#0001	% Get a 1 for bit positioning

	SL	$7,$6,$1	% Bring Iterator-Bit to start position

	SL	$2,$6,$2	% Convert bit-number (of last-bit) to bit

1H	LDOU	$10,$3,0	% "Push" bit-text-pointer,
	PUSHJ	$9,PrintS	% and print it.

	SUBU	$9,$4,$9	% Subtract actual text-length from max length
	GETA	$10,Spaces	% Get adress behind last space
	SUBU	$10,$10,$9	% Move back, to fill until max-length
	PUSHJ	$9,PrintS	% Print fill-spaces

	AND	$6,$0,$7	% Check if actual Bit is set
	BZ	$6,2F
				% Bit is set
	GETA	$10,T_Set	% Set "set"-textpointer
	JMP	3F
				% Bit is not set
2H	GETA	$10,T_Clear	% Set "clear"-textpointer

3H	PUSHJ	$9,PrintS	% Print out
	PUSHJ	$9,PrintLF

	CMP	$6,$7,$2	% Check for end
	PBNZ	$6,4F		% 
	PUT	rJ,$5		% If end reached restore rJ
	POP	0,0		% and return

4H	SL	$7,$7,1		% Move bit forward
	ADDU	$3,$3,8		% Increment Textpointer
	JMP	1B	


%
%	Setup Textpointertable for rK and rQ.
%

Init	GETA	$1,Txt_Ptr
	GETA	$0,T_QKP_R	
	STOU	$0,$1,#00
	GETA	$0,T_QKP_W
	STOU	$0,$1,#08
	GETA	$0,T_QKP_X
	STOU	$0,$1,#10
	GETA	$0,T_QKP_N
	STOU	$0,$1,#18
	GETA	$0,T_QKP_K
	STOU	$0,$1,#20
	GETA	$0,T_QKP_B
	STOU	$0,$1,#28
	GETA	$0,T_QKP_S
	STOU	$0,$1,#30
	GETA	$0,T_QKP_P
	STOU	$0,$1,#38
	POP	0,0


%Start	PUSHJ	$0,Init
%	GET	$1,rV
%	PUSHJ	$0,PrintH
%	PUSHJ	$0,WrtTrap
%	PUSHJ	$0,WrtTrap
%
%Ende	JMP	Ende

Text	BYTE	"Das ist ein Text",#0d,#0a,0,0
HexBuf	BYTE	"00000000000000000",#0d,#0a,0
T_Set	BYTE	"set",0
T_Clear	BYTE	"clear",0,0,0
T_QKP_R	BYTE	"read perm",0,0,0
T_QKP_W	BYTE	"write perm",0,0
T_QKP_X	BYTE	"exec perm",0,0,0
T_QKP_N	BYTE	"Ref. 2 neg virt.",0,0,0,0
T_QKP_K	BYTE	"Privileged Instr.",0,0,0
T_QKP_B BYTE	"break mmix-rules",0,0,0,0
T_QKP_S	BYTE	"Security",0,0,0,0
T_QKP_P BYTE	"Instr. comes from -",0

SpcStrt	BYTE	"                                                "
Spaces	BYTE	#0,#0,#0,#0
Txt_Ptr	OCTA	#0,#0,#0,#0,#0,#0,#0,#0




%
% testing software virtual address translation
% (example from mmix-doc)
%

vinit	OCTA	#0000000000001234
rVinit	OCTA	#32100D0000000001

base	IS	$8
limit	IS	$9
virt	IS	$10
mask	IS	$11
s	IS	$12

% rV must first be inited with a meaningful value
Start	PUSHJ	$0,Init
	PUSHJ	$0,WrtTrap
	SETL	virt,#0		% sample virtual address
	SETH	$1,#3210
	ORMH	$1,#0D00
	ORML	$1,#0020	% Set rootlocation to #0100
	ORL	$1,#0001	% sample config for rV (Aplha21064)
	PUT	rV,$1
% usually done: GET virt, rYY
	GET	$7,rV		% $7=rightmost three bits
	AND	$1,$7,#7	% $1=rightmost three bits
	BZ	$1,Fail		% should be zero
	SRU	$1,virt,61	% $1=i (segment number)
	SLU	$1,$1,2
	NEG	$1,52,$1	% $1=52-4i
	SRU	$1,$7,$1
	SLU	$2,$1,4
	SETL	$0,#f000
	AND	$1,$1,$0	% $1=b[i]<<12
	AND	$2,$2,$0	% $2=b[i+1]<<12
	SLU	$3,$7,24
	SRU	$3,$3,37
	SLU	$3,$3,13	% $3=(r field of rV)
	ORH	$3,#8000	% make $3 a physical address
	2ADDU	base,$1,$3	% base=address of first page table
	2ADDU	limit,$2,$3	% limit=address after last page table
	SRU	s,$7,40
	AND	s,s,#ff		% s=(s field of rV)
	CMP	$0,s,13
	BN	$0,Fail		% s must be 13 or more
	CMP	$0,s,49
	BNN	$0,Fail		% s must be 48 or less
	SETH	mask,#8000
	ORL	mask,#1ff8	% mask=(sign bit and n field)
	ORH	$7,#8000	% set sign bit for PTP validation below
	SRU	$0,virt,s	% $0=a4a3a2a1a0 (page number of virt)
	ZSZ	$1,$0,1		% $1=[page number is zero]
	ADD	limit,limit,$1	% increase limit if page number is zero
% find digits of page number (a4,a3,a2,a1,a0)
% from right to left
	SETL	$6,#3ff		% 10 bits
	SET	$5,base		%
	SRU	$1,$0,10
	PBZ	$1,1F
	AND	$0,$0,$6
	INCL	base,#2000
	SET	$5,base		%
	SRU	$2,$1,10
	PBZ	$2,2F
	AND	$1,$1,$6
	INCL	base,#2000
	SET	$5,base		%
	SRU	$3,$2,10
	PBZ	$3,3F
	AND	$2,$2,$6
	INCL	base,#2000
	SET 	$5,base		%
	SRU	$4,$3,10
	PBZ	$4,4F
	AND	$3,$3,$6
	INCL	base,#2000
% cascade back through PTPs
	SET	$5,base
	8ADDU	$6,$4,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
	ANDNL	base,#1fff	%
4H	8ADDU	$6,$3,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
	ANDNL	base,#1fff	%
3H	8ADDU	$6,$2,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
	ANDNL	base,#1fff	%
2H	8ADDU	$6,$1,base
	LDO	base,$6,0
	XOR	$6,base,$7
	AND	$6,$6,mask
	BNZ	$6,Fail
% obtain PTE
	ANDNL	base,#1fff	% remove low 13 bits of PTP
1H	8ADDU	$6,$0,base
	LDO	base,$6,0	% base=PTE
	XOR	base,base,$7
	ANDN	$6,base,#7
	SLU	$6,$6,51
	BNZ	$6,Fail		% branch if n does not match
	CMP	$6,$5,limit
	BN	$6,Ready	% access beyond page-table?
Fail	SETL	base,0		% errors lead to PTE of zero
	PUSHJ	$11,WrtTrap
	TRAP
Ready	PUSHJ	$11,WrtTrap
	TRAP
% usually put base in rZZ
%Ready	PUT	rZZ,base
%	LDO	$255,IntMask
%	RESUME	1

	LOC	2097152

PTE	OCTA	#0000abcdabcde004


