/*
 * except.h -- exception handling
 */


#ifndef _EXCEPT_H_
#define _EXCEPT_H_


#define EXC_NONE	0	/* no exception present */

#define EXC_FT_TRAP	-1	/* trap instruction */
#define EXC_FT_EMUL	-2	/* emulated instruction */
#define EXC_FT_VAT	-3	/* virtual address translation */

#define EXC_DT_POWER	1	/* power failure */
#define EXC_DT_PARITY	2	/* parity error */
#define EXC_DT_MEMERR	3	/* nonexistent memory or I/O */
#define EXC_DT_WRPROT	4	/* write-protected memory or I/O */
#define EXC_DT_REBOOT	5	/* reboot signal */
#define EXC_DT_06	6	/* - not allocated - */
#define EXC_DT_07	7	/* - not allocated - */
#define EXC_DT_TIMER	8	/* interval timeout */

#define EXC_DT_09	9	/* - not allocated - */
#define EXC_DT_10	10	/* - not allocated - */
#define EXC_DT_11	11	/* - not allocated - */
#define EXC_DT_12	12	/* - not allocated - */
#define EXC_DT_13	13	/* - not allocated - */
#define EXC_DT_14	14	/* - not allocated - */
#define EXC_DT_15	15	/* - not allocated - */
#define EXC_DT_16	16	/* - not allocated - */
#define EXC_DT_17	17	/* - not allocated - */
#define EXC_DT_18	18	/* - not allocated - */
#define EXC_DT_19	19	/* - not allocated - */
#define EXC_DT_20	20	/* - not allocated - */
#define EXC_DT_21	21	/* - not allocated - */
#define EXC_DT_22	22	/* - not allocated - */
#define EXC_DT_23	23	/* - not allocated - */
#define EXC_DT_24	24	/* - not allocated - */
#define EXC_DT_25	25	/* - not allocated - */
#define EXC_DT_26	26	/* - not allocated - */
#define EXC_DT_27	27	/* - not allocated - */
#define EXC_DT_28	28	/* - not allocated - */
#define EXC_DT_29	29	/* - not allocated - */
#define EXC_DT_30	30	/* - not allocated - */
#define EXC_DT_31	31	/* - not allocated - */
#define EXC_DT_32	32	/* - not allocated - */

#define EXC_DT_P	33	/* instruction in privileged location */
#define EXC_DT_S	34	/* security violation */
#define EXC_DT_B	35	/* instruction breaks the rules */
#define EXC_DT_K	36	/* instruction for kernel only */
#define EXC_DT_N	37	/* virtual translation bypassed */
#define EXC_DT_X	38	/* permission lacking to execute from page */
#define EXC_DT_W	39	/* permission lacking to write on page */
#define EXC_DT_R	40	/* permission lacking to read from page */

#define EXC_DT_41	41	/* - not allocated - */
#define EXC_DT_42	42	/* - not allocated - */
#define EXC_DT_43	43	/* - not allocated - */
#define EXC_DT_44	44	/* - not allocated - */
#define EXC_DT_45	45	/* - not allocated - */
#define EXC_DT_46	46	/* - not allocated - */
#define EXC_DT_47	47	/* - not allocated - */
#define EXC_DT_48	48	/* - not allocated - */
#define EXC_DT_49	49	/* - not allocated - */
#define EXC_DT_50	50	/* - not allocated - */
#define EXC_DT_51	51	/* - not allocated - */
#define EXC_DT_52	52	/* - not allocated - */
#define EXC_DT_53	53	/* - not allocated - */
#define EXC_DT_54	54	/* - not allocated - */
#define EXC_DT_55	55	/* - not allocated - */
#define EXC_DT_56	56	/* - not allocated - */
#define EXC_DT_57	57	/* - not allocated - */
#define EXC_DT_58	58	/* - not allocated - */
#define EXC_DT_59	59	/* - not allocated - */
#define EXC_DT_60	60	/* - not allocated - */
#define EXC_DT_61	61	/* - not allocated - */
#define EXC_DT_62	62	/* - not allocated - */
#define EXC_DT_63	63	/* - not allocated - */
#define EXC_DT_64	64	/* - not allocated - */


char *exceptionToString(int exception);
void throwException(int exception);
void pushEnvironment(jmp_buf *environment);
void popEnvironment(void);


#endif /* _EXCEPT_H_ */
