/*
 * arith.h -- arithmetic subroutines
 */


#ifndef _ARITH_H_
#define _ARITH_H_


extern octa zero_octa;
extern octa one_octa;
extern octa neg_one;

extern octa aux;
extern bool overflow;

extern int cur_round;
extern int exceptions;


octa oplus(octa y, octa z);
octa ominus(octa y, octa z);
octa incr(octa y, int delta);
octa shift_left(octa y, int s);
octa shift_right(octa y, int s, int u);
octa omult(octa y, octa z);
octa signed_omult(octa y, octa z);
octa odiv(octa x, octa y, octa z);
octa signed_odiv(octa y, octa z);
octa oand(octa y, octa z);
octa oandn(octa y, octa z);
octa onand(octa y, octa z);
octa oor(octa y, octa z);
octa oorn(octa y, octa z);
octa onor(octa y, octa z);
octa oxor(octa y, octa z);
octa onxor(octa y, octa z);
int count_bits(tetra x);
tetra byte_diff(tetra y, tetra z);
tetra wyde_diff(tetra y, tetra z);
octa bool_mult(octa y, octa z, bool xor);
octa load_sf(tetra z);
tetra store_sf(octa x);
octa fmult(octa y, octa z);
octa fdivide(octa y, octa z);
octa fplus(octa y, octa z);
int fepscomp(octa y, octa z, octa e, int s);
int fcomp(octa y, octa z);
octa fintegerize(octa z, int r);
octa fixit(octa z, int r);
octa floatit(octa z, int r, int u, int p);
octa froot(octa z, int r);
octa fremstep(octa y, octa z, int delta);


#endif /* _ARITH_H_ */
