%
% dmbr.mms -- the default master boot record
%

	LOC	#8000000000000000

% $0 return address
% $1 pointer to string
% $2 temporary
% $3 character (argument)

Main	GETA	$1,Msg			% pointer to string
Loop	LDBU	$3,$1,0			% get char
	BZ	$3,Done			% null - finished
	PUSHJ	$2,Out			% output char
	ADDU	$1,$1,1			% bump pointer
	JMP	Loop			% next char
Done	GO	$0,$0,0			% return to caller

% $0 character (parameter)
% $1 I/O base address
% $2 temporary

Out	SETH	$1,#8001		% set I/O base address
Out1	SYNC	0			% drain pipeline
	LDOU	$2,$1,16		% get transmitter status
	AND	$2,$2,#01		% ready?
	PBZ	$2,Out1			% no - wait
	STOU	$0,$1,24		% send char
	SYNCD	7,$1,24			% empty write buffer
	POP	0,0			% return

	LOC	@+(4-@)&3
Msg	BYTE	#0D,#0A
	BYTE	"Error: This is the default MBR, "
	BYTE	"which cannot load anything."
	BYTE	#0D,#0A
	BYTE	"Please replace the disk, or "
	BYTE	"write an operating system onto it."
	BYTE	#0D,#0A
	BYTE	#0D,#0A,0

	LOC	#80000000000001FE
Sign	BYTE	#55,#AA
